# The 3n + 1 Problem

This is an old one. One of the first programming problems I ever solved. Not very difficult to get it right, not very difficult to make it fast.

The 3n + 1 Problem is problem 100 in the UVa Online Judge. Even though I include the problem description in this post, I encourage you to visit the UVa Online Judge because there you will be able to submit your solution to get it judged.

# Problem

Consider the following algorithm.

Given the input 22, the following sequence of numbers will be printed
`22 11 34 17 52 26 13 40 20 10 5 16 8 4 2 1`

.

It is conjectured that the algorithm above will terminate for any
integral input value. This conjecture is the Collatz
Conjecture.
Despite the simplicity of the algorithm, it is unknown whether this
conjecture is true. It has been verified, however, for all integers
`n`

such that `0 < n < 1,000,000`

(and, in fact, for many more numbers
than this.)

Given an input `n`

, it is possible to determine the number of numbers
printed (including the 1). For a given `n`

this is called the
cycle-length of `n`

. In the example above, the cycle length of 22 is
16.

For any two numbers `i`

and `j`

you are to determine the maximum cycle
length over all numbers between `i`

and `j`

.

# Input

The input will consist of a series of pairs of integers `i`

and `j`

,
one pair of integers per line. All integers will be less than
`1,000,000`

and greater than `0`

.

You should process all pairs of integers and for each pair determine
the maximum cycle length over all integers between and including `i`

and `j`

.

You can assume that no operation overflows a 32-bit integer.

# Output

For each pair of input integers `i`

and `j`

you should output `i`

,
`j`

, and the maximum cycle length for integers between and including
`i`

and `j`

. These three numbers should be separated by at least one
space with all three numbers on one line and with one line of output
for each line of input. The integers `i`

and `j`

must appear in the output
in the same order in which they appeared in the input and should be
followed by the maximum cycle length (on the same line).

# Sample Input

# Sample Output

# Solution

Consider the following solution. Function `collatz_len`

computes the
cycle length of a given integer. Each recursive call corresponds to an
assignment in the algorithm of the problem statement. The numbers in
the left margin indicate execution count for a random
input.

We reduce the number of steps taken to solve the random input by
memoizing the cycle lengths. The following solution memoizes calls
for `n`

less than 1,000,000. Memoization reduces the number of calls
one order of magnitude because the calls to `collatz_len`

decreased
from ~11,400,000 steps to ~900,000 and we added ~3,000,000 steps for
initialization in line 26.

# Discussion

Our solution ranks 183 in the UVa Online Judge. There are submissions with reported runtimes of 0.000 seconds. I have yet to figure out a faster solution.

# Want to read more?

I love to explain and answer questions on programming problems, the kind you find in coding interviews. I publish a new programming problem and its solution every Sunday. Did I mention that I love to answer questions?

If you would like to get the latest problem + solution, subscribe to the newsletter or subscribe via RSS. You can also follow me on Twitter, GitHub, and LinkedIn.